'#################################################################################################
'#
'#   Yahoo Socket Class
'#
'#   Purpose: To communicate over Yahoo Chat service.
'#
'#   Written by Xeon Productions
'#   Copyright 2004 Xeon Productions
'#   Contact: Brandon Scott [xeons@xeons.net]
'#   Website: http://www.xeons.net/
'# 
'#   If you use this code please ask permission first, or give
'#   credit where credit is due.
'#
'#################################################################################################
Imports System.Text
Imports System.Text.RegularExpressions

Module YahooMiscellaneous

    Public Const YMSG_PROTO_HEADERLENGTH As Integer = 20
    Public Const YMSG_PROTO_IDENTIFIER As String = "YMSG"
    Public Const YMSG_PROTO_VERSION As Integer = 12
    Public Const YMSG_PROTO_VENDORID As Integer = 0
    Public Const YMSG_PROTO_SEPERATOR As Integer = &HC080
    Public Const YMSG_CMD_LOGON = 1
    Public Const YMSG_CMD_LOGOFF = 2
    Public Const YMSG_CMD_ISAWAY = 3
    Public Const YMSG_CMD_ISBACK = 4
    Public Const YMSG_CMD_IDLE = 5
    Public Const YMSG_CMD_MESSAGE = 6
    Public Const YMSG_CMD_IDACT = 7
    Public Const YMSG_CMD_IDDEACT = 8
    Public Const YMSG_CMD_MAILSTAT = 9
    Public Const YMSG_CMD_USERSTAT = 10
    Public Const YMSG_CMD_NEWMAIL = 11
    Public Const YMSG_CMD_CHATINVITE = 12
    Public Const YMSG_CMD_CALENDAR = 13
    Public Const YMSG_CMD_NEWPERSONALMAIL = 14
    Public Const YMSG_CMD_NEWCONTACT = 15
    Public Const YMSG_CMD_ADDIDENT = 16
    Public Const YMSG_CMD_ADDIGNORE = 17
    Public Const YMSG_CMD_PING = 18
    Public Const YMSG_CMD_GOTGROUPRENAME = 19
    Public Const YMSG_CMD_SYSMESSAGE = 20
    Public Const YMSG_CMD_SKINNAME = 21
    Public Const YMSG_CMD_PASSTHROUGH2 = 22
    Public Const YMSG_CMD_CONFINVITE = 24
    Public Const YMSG_CMD_CONFLOGON = 25
    Public Const YMSG_CMD_CONFDECLINE = 26
    Public Const YMSG_CMD_CONFLOGOFF = 27
    Public Const YMSG_CMD_CONFADDINVITE = 28
    Public Const YMSG_CMD_CONFMSG = 29
    Public Const YMSG_CMD_CHATLOGON = 30
    Public Const YMSG_CMD_CHATLOGOFF = 31
    Public Const YMSG_CMD_CHATMSG = 32
    Public Const YMSG_CMD_GAMELOGON = 40
    Public Const YMSG_CMD_GAMELOGOFF = 41
    Public Const YMSG_CMD_GAMEMSG = 42
    Public Const YMSG_CMD_FILETRANSFER = 70
    Public Const YMSG_CMD_VOICECHAT = 74
    Public Const YMSG_CMD_NOTIFY = 75
    Public Const YMSG_CMD_VERIFY = 76
    Public Const YMSG_CMD_P2PFILEXFER = 77
    Public Const YMSG_CMD_PEEPTOPEER = 79
    Public Const YMSG_CMD_WEBCAM = 80
    Public Const YMSG_CMD_AUTHRESP = 84
    Public Const YMSG_CMD_LIST = 85
    Public Const YMSG_CMD_AUTH = 87
    Public Const YMSG_CMD_ADDBUDDY = 131
    Public Const YMSG_CMD_REMBUDDY = 132
    Public Const YMSG_CMD_IGNORECONTACT = 133
    Public Const YMSG_CMD_REJECTCONTACT = 134
    Public Const YMSG_CMD_GROUPRENAME = 137
    Public Const YMSG_CMD_CHATONLINE = 150
    Public Const YMSG_CMD_CHATGOTO = 151
    Public Const YMSG_CMD_CHATJOIN = 152
    Public Const YMSG_CMD_CHATLEAVE = 153
    Public Const YMSG_CMD_CHATEXIT = 155
    Public Const YMSG_CMD_CHATADDINVITE = 157
    Public Const YMSG_CMD_CHATLOGOUT = 160
    Public Const YMSG_CMD_CHATPING = 161
    Public Const YMSG_CMD_COMMENT = &HA8
    Public Const YMSG_CMD_AVATAR = &HBC
    Public Const YMSG_CMD_PICTURE_CHECKSUM = &HBD
    Public Const YMSG_CMD_PICTURE = &HBE
    Public Const YMSG_CMD_PICTURE_UPDATE = &HC1
    Public Const YMSG_CMD_PICTURE_UPLOAD = &HC2
    Public Const YMSG_CMD_YAHOO6_STATUS_UPDATE = &HC6
    Public Const YMSG_CMD_AVATAR_UPDATE = &HC7
    Public Const YMSG_CMD_AUDIBLE = &HD0
    Public Const YMSG_CMD_WEBLOGIN = &H226
    Public Const YMSG_CMD_SMS_MSG = &H2EA

    Public Const YMSG_STATUS_AVAILABLE = 0
    Public Const YMSG_STATUS_BRB = 1
    Public Const YMSG_STATUS_BUSY = 2
    Public Const YMSG_STATUS_NOTATHOME = 3
    Public Const YMSG_STATUS_NOTATDESK = 4
    Public Const YMSG_STATUS_NOTINOFFICE = 5
    Public Const YMSG_STATUS_ONPHONE = 6
    Public Const YMSG_STATUS_ONVACATION = 7
    Public Const YMSG_STATUS_OUTTOLUNCH = 8
    Public Const YMSG_STATUS_STEPPEDOUT = 9
    Public Const YMSG_STATUS_INVISIBLE = 12
    Public Const YMSG_STATUS_CUSTOM = 99
    Public Const YMSG_STATUS_IDLE = 999
    Public Const YMSG_STATUS_WEBLOGIN = 1515563605
    Public Const YMSG_STATUS_OFFLINE = 1515563606
    Public Const YMSG_STATUS_TYPING = 22

    Public Function DecodeYahooString(ByVal Data As String, ByVal UTF8 As Boolean) As String
        Dim UTF8Bytes() As Byte = Encoding.UTF8.GetBytes(Data)
        Dim ASCIIBytes() As Byte = Encoding.ASCII.GetBytes(Data)
        Dim ANSIBytes() As Byte = Encoding.Convert(Encoding.UTF8, Encoding.Default, UTF8Bytes)
        If UTF8 = True Then
            Return Encoding.Default.GetString(ANSIBytes)
        Else
            Return Encoding.Default.GetString(ASCIIBytes)
        End If
    End Function

    Public Function EncodeYahooString(ByVal Data As String, ByVal UTF8 As Boolean) As String
        Dim UTF8Bytes() As Byte = Encoding.UTF8.GetBytes(Data)
        Dim ASCIIBytes() As Byte = Encoding.ASCII.GetBytes(Data)
        If UTF8 = True Then
            Return Encoding.Default.GetString(UTF8Bytes)
        Else
            Return Encoding.Default.GetString(ASCIIBytes)
        End If
    End Function

    Public Function StripHTML(ByVal strIn As String) As String
        Dim pattern As String = "<(.|\n)*?>"
        StripHTML = Regex.Replace(strIn, pattern, String.Empty)
    End Function

    Public Function PutWord(ByVal lngVal As Integer) As String
        Try
            Return Chr(Int(lngVal / 256)) & Chr(lngVal Mod 256)
        Catch ex As Exception
            Return String.Empty
        End Try
    End Function

    Public Function GetWord(ByVal strVal As String) As Integer
        Try
            Return (Asc(strVal.Chars(0)) * 256) + Asc(strVal.Chars(1))
        Catch ex As Exception
            Return 0
        End Try
    End Function

    Public Function PutDWord(ByVal lngVal As Long) As String
        Try
            Return PutWord(Fix(lngVal / 65536)) & PutWord(lngVal Mod 65536)
        Catch ex As Exception
            Return String.Empty
        End Try
    End Function

    'Strange bug in VB.NET, If you have a function that returns
    'Integer, then it doesent use the `Long` operators, uses
    'integer ones by mistake. Causing Arithmic Overflows.
    'QuickFix: Use the infamous CLng function!
    Public Function GetDWord(ByVal strVal As String) As Long
        Try
            Return (CLng(GetWord(strVal.Substring(0, 2))) * 65536) + CLng(GetWord(Mid$(strVal, 3, 2)))
        Catch ex As Exception
            Return 0
        End Try
    End Function

End Module
