'#################################################################################################
'#
'#   Yahoo Socket Class
'#
'#   Purpose: To communicate over Yahoo Chat service.
'#
'#   Written by Xeon Productions
'#   Copyright 2004 Xeon Productions
'#   Contact: Brandon Scott [xeons@xeons.net]
'#   Website: http://www.xeons.net/
'# 
'#   If you use this code please ask permission first, or give
'#   credit where credit is due.
'#
'#################################################################################################

Imports System.Text

Public Class YahooPacket
    Private m_ProtocolVersion As Integer
    Private m_Command As Integer
    Private m_Status As Long
    Private m_SessionID As Long
    Private m_Length As Integer
    Private m_VendorID As Integer
    Private m_Pairs As New Hashtable

    Public Sub New(ByVal Command As Integer, ByVal Status As Long, ByVal SessionID As Long)
        m_Command = Command
        m_Status = Status
        m_SessionID = SessionID
    End Sub

    Public Sub New(ByVal Command As Integer, ByVal Status As Long)
        m_Command = Command
        m_Status = Status
        m_SessionID = 0
    End Sub

    Public Sub New(ByVal Command As Integer)
        m_Command = Command
        m_Status = 0
        m_SessionID = 0
    End Sub

    Public Sub New()

    End Sub

    Public Sub New(ByVal Buffer As String)
        Dim Pairs() As String
        m_ProtocolVersion = GetWord(Buffer.Substring(4, 2))
        m_VendorID = GetWord(Buffer.Substring(6, 2))
        m_Length = GetWord(Buffer.Substring(8, 2))
        m_Command = GetWord(Buffer.Substring(10, 2))
        m_Status = GetDWord(Buffer.Substring(12, 4))
        m_SessionID = GetDWord(Buffer.Substring(16, 4))
        Pairs = Split(Buffer.Substring(20), PutWord(YMSG_PROTO_SEPERATOR))
        For i As Integer = 0 To Pairs.GetUpperBound(0) - 1 Step 2
            If IsNumeric(Pairs(i)) Then
                AddPair(Pairs(i), Pairs(i + 1))
            End If
        Next i
    End Sub

    Public ReadOnly Property Pairs() As Hashtable
        Get
            Return m_Pairs
        End Get
    End Property

    Public ReadOnly Property ProtocolVersion() As Integer
        Get
            Return m_ProtocolVersion
        End Get
    End Property

    Public ReadOnly Property VendorID() As Integer
        Get
            Return m_VendorID
        End Get
    End Property

    Public ReadOnly Property Length() As Integer
        Get
            Return m_Length
        End Get
    End Property

    Public Property Command() As Integer
        Get
            Return m_Command
        End Get
        Set(ByVal Value As Integer)
            m_Command = Value
        End Set
    End Property

    Public Property Status() As Long
        Get
            Return m_Status
        End Get
        Set(ByVal Value As Long)
            m_Status = Value
        End Set
    End Property

    Public Property SessionID() As Long
        Get
            Return m_SessionID
        End Get
        Set(ByVal Value As Long)
            m_SessionID = Value
        End Set
    End Property

    Public Function AddPair(ByVal Key As Integer, ByVal Value As String) As Boolean
        Try
            m_Pairs.Add(Key, Value)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function RemovePair(ByVal Key As Integer) As Boolean
        Try
            m_Pairs.Remove(Key)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function GetPair(ByVal Key As Integer) As String
        Try
            Return m_Pairs.Item(Key)
        Catch ex As Exception
            Return String.Empty
        End Try
    End Function

    Public Overrides Function ToString() As String
        Dim DataBuffer As New StringBuilder
        Dim ReturnBuffer As New StringBuilder
        Dim en As IDictionaryEnumerator = m_Pairs.GetEnumerator
        'We cycle through all the packet variables
        While en.MoveNext
            DataBuffer.Append(en.Key)
            DataBuffer.Append(PutWord(YMSG_PROTO_SEPERATOR))
            DataBuffer.Append(en.Value)
            DataBuffer.Append(PutWord(YMSG_PROTO_SEPERATOR))
        End While
        'We form the header and append the packet variables to it.
        ReturnBuffer.Append(YMSG_PROTO_IDENTIFIER)
        ReturnBuffer.Append(PutWord(YMSG_PROTO_VERSION))
        ReturnBuffer.Append(PutWord(YMSG_PROTO_VENDORID))
        ReturnBuffer.Append(PutWord(DataBuffer.Length))
        ReturnBuffer.Append(PutWord(m_Command))
        ReturnBuffer.Append(PutDWord(m_Status))
        ReturnBuffer.Append(PutDWord(m_SessionID))
        ReturnBuffer.Append(DataBuffer.ToString)
        Return ReturnBuffer.ToString
    End Function
End Class